var FONT_SIZE_INCREASE = 10;
var fsDictionary = {};

function checkFontSize(elem) {
    if (elem.childNodes != null)
    {
        for (var i = 0 ; i < elem.childNodes.length ; i++)
        {
            checkFontSize(elem.childNodes[i]);
        }
    }

    if (elem.nodeType != 1)
    {
        return;
    }

    var fontSize;
    console.log('Creating key...');
    var key = elem.tagName + '_' + elem.className + '_' + elem.style.fontSize;
    if (fsDictionary[key] !== undefined && fsDictionary[key] !== null)
    {
        var start = new Date();
        console.log('Key: "' + key + '" existed in cache');
        fontSize = fsDictionary[key];
        var end = new Date();
        var diff = end - start; // time difference in milliseconds
        console.log("Key: " + key + " retrieval from cache " + diff + "ms to calculate. FontSize: " + fontSize);
    }
    else {
        console.log("Key: " + key + " is not in cache, calculating font size...");
        var start = new Date();
        fontSize = window.getComputedStyle(elem).fontSize; // Triggers DOM reflow, this line is very expensive
        var end = new Date();
        var diff = end - start; // time difference in milliseconds
        console.log("Key: " + key + " took " + diff + "ms to calculate. FontSize: " + fontSize);

        var start = Date();

        fontSize = window.getComputedStyle(elem).fontSize;
        var unit = fontSize.substring(fontSize.length - 2, fontSize.length);
        fontSize = Number(fontSize.substring(0, fontSize.length - 2));
        fontSize = fontSize + FONT_SIZE_INCREASE + unit;

        // Store the value in the dictionary
        console.log('Key: "' + key + '" written to cache');
        fsDictionary[key] = fontSize;
    }

    elem.style.fontSize = fontSize; // Triggers DOM reflow
    console.log('Key: "' + key + '" font size updated');
}

checkFontSize(document.body);